package FDN::Test::Plutar;

use strict;
use Exporter ;
our @ISA = ( 'Exporter' ) ;

our @EXPORT = qw (
	essai
	essai_success
	essai_fail
	essai_retry

	get_dbh
	get_notify
	);
our @EXPORT_OK = qw ();
our %EXPORT_TAGS = ();

# This package is the testcase for the Plutar libs and tools.
# It is also a minimal example of how to use Plutar.
use strict;
use FDN::Sql::DBC;
use FDN::Sql::Plutar::Constantes; # Return values for activities
#use FDN::Test::Basic; # Access to our database, not required for testing,
#                      # but would be usefull in any other reasonable context.

our $dbh;
our $notify_str = '';

BEGIN { 
	# Here we use a fake path that should be set by the test script
	# This module will be used by the testing mechanics of plutar.pl,
	# so we *need* to force the CONFIG_ROOT. You must not do that in
	# normal use.
	$FDN::Common::Config::CONFIG_ROOT = './t/';
	$dbh = do_connect('test');
}

sub get_dbh() {
	# This function is required. This is the way plutar will guess the
	# right database.
	return $dbh;
}

sub get_notify() {
	# This function is required. This is the way plutar will guess if
	# your activity asked for a notify message.
	return $notify_str;
}

sub essai($) {
	# This a not totally dummy activity. Your own will probably do more
	# interesting stuff, and will probably use your database, except if
	# you use Plutar only as a larger 'at' program.
	my ( $args ) = @_;
	if ( $args->{'return'} eq 'success' ) {
		return PLUTAR_SUCCESS;
	}
	if ( $args->{'return'} eq 'fail' ) {
		return PLUTAR_FAILED;
	}
	$args->{'return'} = 'success';
	return PLUTAR_RETRY;
}

sub essai_success($) {
	my ( $args ) = @_;
	return PLUTAR_SUCCESS;
}

sub essai_fail($) {
	my ( $args ) = @_;
	return PLUTAR_FAILED;
}

sub essai_retry($) {
	my ( $args ) = @_;
	return PLUTAR_RETRY;
}

1;
